## Code for "Mixed alternating projections with application to Hankel low-rank approximation" paper

This supplementary code is written in R (tested with version 4.2.2) and needs an additional package ("rhlra") to be installed first from the source code.

### "rhlra" package installation

Source code for the package can be obtained here: [rhlra Github repository](https://github.com/furiousbean/rhlra), branch "mixed_projections_paper" (which corresponds to the version of package actual at the moment of paper submission). The easiest way to install it is by using `devtools` package: `devtools::install_github("furiousbean/rhlra", ref = "mixed_projections_paper")`.

However, there are several prerequisites to build the `rhlra` package. Firstly, the package needs compilation, therefore your system must have a working build environment. If you are using Windows it means that `Rtools` must be installed, you can find additional information [here](https://cran.r-project.org/bin/windows/Rtools/rtools42/rtools.html) and [here](https://cran.r-project.org/bin/windows/Rtools/). Secondly, `rhlra` package needs [FFTW](https://www.fftw.org) library to be installed in your build environment. Modern `Rtools` installations, which are based on MSYS/clang, should include FFTW by default. However, in case of older `Rtools` installation we provide [statically prebuilt FFTW library for Windows](https://drive.google.com/file/d/1IlF8GXJ0w6Br0Fea7dmhv4Pn4ASwDxrq/view?usp=sharing), which you can add to your `Rtools` directory (while carefully fixing probable changes in some directory paths).

### Other packages installation
Additionally you have to install the following R packages from CRAN: `install.packages(c("svd", "Matrix", "snow", "expm"))`.

### Running the code
Just source the following file: `make_plots.R`, and it should reproduce figures from the paper. Note that there is a commented time-consuming part of source code that must be uncommented in order to reproduce simulations properly.
